fun leadsto a b = "(("^a^";true)=>("^a^"|("^a^";"^b^";true)))";

fun Ls [] = ""
  | Ls [h1,h2] = "&"^(leadsto h1 h2)
  | Ls (h1::h2::t) = "&"^(leadsto h1 h2)^(Ls (h2::t));

fun Lseq [] = ""
  | Lseq [h1,h2] = (leadsto h1 h2)
  | Lseq (h1::h2::t) = (leadsto h1 h2)^(Ls (h2::t));

fun nega a [] = ""
  | nega a (h::t) = (if (a=h) then (nega a t) else "& '~("^h^")'"^(nega a t));

fun negate a [] = ""
  | negate a (h::t) =  (if (a=h) then (negate a t) else "'~("^h^")'"^(nega a t));

fun ex h t  = "([](('"^h^"'=>("^(negate h t)^"))))";

fun excl [] t = ""
  | excl [h] t = "&"^(ex h t)
  | excl (h::t1) t2 = "&"^(ex h t2)^(excl t1 t2);
  
fun exclusive [] = ""
  | exclusive [h] = ""
  | exclusive (h::t) = (ex h (h::t))^(excl t (h::t));
  
fun incl []  = "'"
  | incl (h::t) = "|"^h^(incl t);
  
fun inclusive [] = ""
  | inclusive (h::t) = "([](''|'"^h^(incl t)^"))";
  
fun enum s = (exclusive s)^"&"^(inclusive s);

fun enumseq [] = "true"
  | enumseq [h] = "("^(enum h)^")"
  | enumseq (h::t) = "("^(enum h)^")&("^(enumseq t)^")";

fun con [] = ""
  | con (h::t) = "&("^h^")"^(con t);

fun conj [] = ""
  | conj (h::t) = "("^h^")"^(con t);

fun ch [] = ""
  | ch (h::t) = ";("^h^")"^(ch t);

fun chop [] = ""
  | chop (h::t) = "("^h^")"^(ch t);

fun pvs_seq_str []      = ""
  | pvs_seq_str [x]     =  x
  | pvs_seq_str (x::xs) = x^"\n "^(pvs_seq_str xs);

fun pvs_output s =
  case s of
     Unsatisfiable => "Unsatisfiable"
   | Counter_example s => "Counter_example\n "^(pvs_seq_str s)
   | Valid => "Valid"
   | Parse_error s => "Parse error at:\n"^s
   | Scan_error s => "Scan error at:\n"^s;
 
fun writefile (filename: string, s: string): unit =
    let val outfile = open_out filename
	val _       = output(outfile, s)
	val _       = close_out outfile
    in () end

fun pvs_valid s [] f =  writefile (f,(pvs_output (dense_valid s)))
  | pvs_valid s e f = writefile (f,(pvs_output (dense_valid ("("^(enumseq e)^")=>("^s^")"))));




