(***************************************************************************
 File "tests.sml" Updated 1993-02-10
 Duration Calculus checker, version 2
 Some test cases.  Execute by typing C-c C-c in Sml mode.
 Sestoft and Skakkebaek, Computer Science, Technical University of Denmark
***************************************************************************)

discrete_valid "''";			(* Counter_example [""] *)
dense_valid "''";			(* Counter_example [""] *)
discrete_valid "~''";			(* Counter_example [] *)


discrete_valid "'p'";			(* Counter_example [] *)
discrete_valid "'~p'";			(* Counter_example [] *)
discrete_valid "'~p'|''";		(* Counter_example ["p"] *)
discrete_valid "~'p'";			(* Counter_example ["p"] *)

discrete_valid "'p'=>'p';'p'";		(* Counter_example ["p"] *)
dense_valid "'p'=>'p';'p'";		(* Valid *)

discrete_valid "('p';'p')=>'p'";	(* Valid *)
dense_valid "('p';'p')=>'p'";   	(* Valid *)

discrete_valid "'p' => 'q'";		(* Counter_example ["p~q"] *)

discrete_valid "[]('p' => 'q') => ('p' => 'q')";	(* Valid *)
dense_valid "[]('p' => 'q') => ('p' => 'q')";		(* Valid *)

discrete_valid "[]<>''";		(* Valid *)

val len1 = "(~''&~((~'');(~'')))";

discrete_valid (len1 ^ "=> ~''");	(* Valid *)

discrete_valid len1;			(* Counter_example [] *)
